diff --git a/oflog/include/dcmtk/oflog/thread/syncprim.h b/oflog/include/dcmtk/oflog/thread/syncprim.h
new file mode 100644
index 0000000..26d4753
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/thread/syncprim.h
@@ -0,0 +1,387 @@
+// -*- C++ -*-
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#ifndef DCMTK_LOG4CPLUS_THREAD_SYNCPRIMS_H
+#define DCMTK_LOG4CPLUS_THREAD_SYNCPRIMS_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread {
+
+
+template <typename SP>
+class SyncGuard
+{
+public:
+    SyncGuard ();
+    SyncGuard (SP const &);
+    ~SyncGuard ();
+
+    void lock ();
+    void unlock ();
+    void attach (SP const &);
+    void attach_and_lock (SP const &);
+    void detach ();
+
+private:
+    SP const * sp;
+
+    SyncGuard (SyncGuard const &);
+    SyncGuard & operator = (SyncGuard const &);
+};
+
+
+class ManualResetEvent;
+
+
+class MutexImplBase
+{
+protected:
+    ~MutexImplBase ();
+};
+
+
+class DCMTK_LOG4CPLUS_EXPORT Mutex
+{
+public:
+    enum Type
+    {
+        DEFAULT,
+        RECURSIVE
+    };
+
+    explicit Mutex (Type = RECURSIVE);
+    ~Mutex ();
+
+    void lock () const;
+    void unlock () const;
+
+private:
+    MutexImplBase * mtx;
+
+    Mutex (Mutex const &);
+    Mutex & operator = (Mutex &);
+};
+
+
+typedef SyncGuard<Mutex> MutexGuard;
+
+
+class SemaphoreImplBase
+{
+protected:
+    ~SemaphoreImplBase ();
+};
+
+
+class DCMTK_LOG4CPLUS_EXPORT Semaphore
+{
+public:
+    Semaphore (unsigned max, unsigned initial);
+    ~Semaphore ();
+
+    void lock () const;
+    void unlock () const;
+
+private:
+    SemaphoreImplBase * sem;
+
+    Semaphore (Semaphore const &);
+    Semaphore & operator = (Semaphore const &);
+};
+
+
+typedef SyncGuard<Semaphore> SemaphoreGuard;
+
+
+class FairMutexImplBase
+{
+protected:
+    ~FairMutexImplBase ();
+};
+
+
+class DCMTK_LOG4CPLUS_EXPORT FairMutex
+{
+public:
+    FairMutex ();
+    ~FairMutex ();
+
+    void lock () const;
+    void unlock () const;
+
+private:
+    FairMutexImplBase * mtx;
+
+    FairMutex (FairMutex const &);
+    FairMutex & operator = (FairMutex &);
+};
+
+
+typedef SyncGuard<FairMutex> FairMutexGuard;
+
+
+class ManualResetEventImplBase
+{
+protected:
+    ~ManualResetEventImplBase ();
+};
+
+
+class DCMTK_LOG4CPLUS_EXPORT ManualResetEvent
+{
+public:
+    ManualResetEvent (bool = false);
+    ~ManualResetEvent ();
+
+    void signal () const;
+    void wait () const;
+    bool timed_wait (unsigned long msec) const;
+    void reset () const;
+
+private:
+    ManualResetEventImplBase * ev;
+
+    ManualResetEvent (ManualResetEvent const &);
+    ManualResetEvent & operator = (ManualResetEvent const &);
+};
+
+
+class SharedMutexImplBase
+{
+protected:
+    ~SharedMutexImplBase ();
+};
+
+
+template <typename SP, void (SP:: * lock_func) () const,
+    void (SP:: * unlock_func) () const>
+class SyncGuardFunc
+{
+public:
+    SyncGuardFunc (SP const &);
+    ~SyncGuardFunc ();
+
+    void lock ();
+    void unlock ();
+    void attach (SP const &);
+    void detach ();
+
+private:
+    SP const * sp;
+
+    SyncGuardFunc (SyncGuardFunc const &);
+    SyncGuardFunc & operator = (SyncGuardFunc const &);
+};
+
+
+class DCMTK_LOG4CPLUS_EXPORT SharedMutex
+{
+public:
+    SharedMutex ();
+    ~SharedMutex ();
+
+    void rdlock () const;
+    void rdunlock () const;
+
+    void wrlock () const;
+    void wrunlock () const;
+
+private:
+    SharedMutexImplBase * sm;
+
+    SharedMutex (SharedMutex const &);
+    SharedMutex & operator = (SharedMutex const &);
+};
+
+
+// Why is this unused?!? (I had to remove this to make MSC6 happy)
+#if 0
+typedef SyncGuardFunc<SharedMutex, &SharedMutex::rdlock,
+    &SharedMutex::rdunlock> SharedMutexReaderGuard;
+
+
+typedef SyncGuardFunc<SharedMutex, &SharedMutex::wrlock,
+    &SharedMutex::wrunlock> SharedMutexWriterGuard;
+#endif
+
+
+//
+//
+//
+
+template <typename SP>
+inline
+SyncGuard<SP>::SyncGuard ()
+    : sp (0)
+{ }
+
+
+template <typename SP>
+inline
+SyncGuard<SP>::SyncGuard (SP const & m)
+    : sp (&m)
+{
+    sp->lock ();
+}
+
+
+template <typename SP>
+inline
+SyncGuard<SP>::~SyncGuard ()
+{
+    if (sp)
+        sp->unlock ();
+}
+
+
+template <typename SP>
+inline
+void
+SyncGuard<SP>::lock ()
+{
+    sp->lock ();
+}
+
+
+template <typename SP>
+inline
+void
+SyncGuard<SP>::unlock ()
+{
+    sp->unlock ();
+}
+
+
+template <typename SP>
+inline
+void
+SyncGuard<SP>::attach (SP const & m)
+{
+    sp = &m;
+}
+
+
+template <typename SP>
+inline
+void
+SyncGuard<SP>::attach_and_lock (SP const & m)
+{
+    attach (m);
+    try
+    {
+        lock();
+    }
+    catch (...)
+    {
+        detach ();
+        throw;
+    }
+}
+
+
+template <typename SP>
+inline
+void
+SyncGuard<SP>::detach ()
+{
+    sp = 0;
+}
+
+
+//
+//
+//
+
+template <typename SP, void (SP:: * lock_func) () const,
+    void (SP:: * unlock_func) () const>
+inline
+SyncGuardFunc<SP, lock_func, unlock_func>::SyncGuardFunc (SP const & m)
+    : sp (&m)
+{
+    (sp->*lock_func) ();
+}
+
+
+template <typename SP, void (SP:: * lock_func) () const,
+    void (SP:: * unlock_func) () const>
+inline
+SyncGuardFunc<SP, lock_func, unlock_func>::~SyncGuardFunc ()
+{
+    if (sp)
+        (sp->*unlock_func) ();
+}
+
+
+template <typename SP, void (SP:: * lock_func) () const,
+    void (SP:: * unlock_func) () const>
+inline
+void
+SyncGuardFunc<SP, lock_func, unlock_func>::lock ()
+{
+    (sp->*lock_func) ();
+}
+
+
+template <typename SP, void (SP:: * lock_func) () const,
+    void (SP:: * unlock_func) () const>
+inline
+void
+SyncGuardFunc<SP, lock_func, unlock_func>::unlock ()
+{
+    (sp->*unlock_func) ();
+}
+
+
+template <typename SP, void (SP:: * lock_func) () const,
+    void (SP:: * unlock_func) () const>
+inline
+void
+SyncGuardFunc<SP, lock_func, unlock_func>::attach (SP const & m)
+{
+    sp = &m;
+}
+
+
+template <typename SP, void (SP:: * lock_func) () const,
+    void (SP:: * unlock_func) () const>
+inline
+void
+SyncGuardFunc<SP, lock_func, unlock_func>::detach ()
+{
+    sp = 0;
+}
+
+
+} } // namespace log4cplus { namespace thread { 
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_THREAD_SYNCPRIMS_H
diff --git a/oflog/include/dcmtk/oflog/thread/syncpub.h b/oflog/include/dcmtk/oflog/thread/syncpub.h
new file mode 100644
index 0000000..41dcafc
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/thread/syncpub.h
@@ -0,0 +1,301 @@
+// -*- C++ -*-
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#ifndef DCMTK_LOG4CPLUS_THREAD_SYNCPRIMS_PUB_IMPL_H
+#define DCMTK_LOG4CPLUS_THREAD_SYNCPRIMS_PUB_IMPL_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#if (defined (DCMTK_LOG4CPLUS_INLINES_ARE_EXPORTED)           \
+    && defined (DCMTK_LOG4CPLUS_BUILD_DLL))                   \
+    || defined (DCMTK_LOG4CPLUS_ENABLE_SYNCPRIMS_PUB_IMPL)
+#include "dcmtk/oflog/thread/syncprim.h"
+
+#if defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+#  define DCMTK_LOG4CPLUS_THREADED(x)
+#else
+#  include "dcmtk/oflog/thread/impl/syncimpl.h"
+#  define DCMTK_LOG4CPLUS_THREADED(x) (x)
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread {
+
+
+//
+//
+//
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+MutexImplBase::~MutexImplBase ()
+{ }
+
+
+//
+//
+//
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+Mutex::Mutex (Mutex::Type t)
+    : mtx (DCMTK_LOG4CPLUS_THREADED (new impl::Mutex (t)) + 0)
+{ }
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+Mutex::~Mutex ()
+{
+    DCMTK_LOG4CPLUS_THREADED (delete OFstatic_cast(impl::Mutex *, mtx));
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+Mutex::lock () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::Mutex *, mtx)->lock ());
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+Mutex::unlock () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::Mutex *, mtx)->unlock ());
+}
+
+
+//
+//
+//
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+SemaphoreImplBase::~SemaphoreImplBase ()
+{ }
+
+
+//
+//
+//
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+Semaphore::Semaphore (unsigned DCMTK_LOG4CPLUS_THREADED (max),
+    unsigned DCMTK_LOG4CPLUS_THREADED (initial))
+    : sem (DCMTK_LOG4CPLUS_THREADED (new impl::Semaphore (max, initial)) + 0)
+{ }
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+Semaphore::~Semaphore ()
+{
+    DCMTK_LOG4CPLUS_THREADED (delete OFstatic_cast(impl::Semaphore *, sem));
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+Semaphore::lock () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::Semaphore *, sem)->lock ());
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+Semaphore::unlock () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::Semaphore *, sem)->unlock ());
+}
+
+
+//
+//
+//
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+FairMutexImplBase::~FairMutexImplBase ()
+{ }
+
+
+//
+//
+//
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+FairMutex::FairMutex ()
+    : mtx (DCMTK_LOG4CPLUS_THREADED (new impl::FairMutex) + 0)
+{ }
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+FairMutex::~FairMutex ()
+{
+    DCMTK_LOG4CPLUS_THREADED (delete OFstatic_cast(impl::FairMutex *, mtx));
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+FairMutex::lock () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::FairMutex *, mtx)->lock ());
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+FairMutex::unlock () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::FairMutex *, mtx)->unlock ());
+}
+
+
+//
+//
+//
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+ManualResetEventImplBase::~ManualResetEventImplBase ()
+{ }
+
+
+//
+//
+//
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+ManualResetEvent::ManualResetEvent (bool DCMTK_LOG4CPLUS_THREADED (sig))
+    : ev (DCMTK_LOG4CPLUS_THREADED (new impl::ManualResetEvent (sig)) + 0)
+{ }
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+ManualResetEvent::~ManualResetEvent ()
+{
+    DCMTK_LOG4CPLUS_THREADED (delete OFstatic_cast(impl::ManualResetEvent *, ev));
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+ManualResetEvent::signal () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::ManualResetEvent *, ev)->signal ());
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+ManualResetEvent::wait () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::ManualResetEvent *, ev)->wait ());
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+bool
+ManualResetEvent::timed_wait (unsigned long DCMTK_LOG4CPLUS_THREADED (msec)) const
+{
+#if defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+    return true;
+#else
+    return OFstatic_cast(impl::ManualResetEvent *, ev)->timed_wait (msec);
+#endif
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+ManualResetEvent::reset () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::ManualResetEvent *, ev)->reset ());
+}
+
+
+//
+//
+//
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+SharedMutexImplBase::~SharedMutexImplBase ()
+{ }
+
+
+//
+//
+//
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+SharedMutex::SharedMutex ()
+    : sm (DCMTK_LOG4CPLUS_THREADED (new impl::SharedMutex) + 0)
+{ }
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+SharedMutex::~SharedMutex ()
+{ }
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+SharedMutex::rdlock () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::SharedMutex *, sm)->rdlock ());
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+SharedMutex::wrlock () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::SharedMutex *, sm)->wrlock ());
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+SharedMutex::rdunlock () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::SharedMutex *, sm)->rdunlock ());
+}
+
+
+DCMTK_LOG4CPLUS_INLINE_EXPORT
+void
+SharedMutex::wrunlock () const
+{
+    DCMTK_LOG4CPLUS_THREADED (OFstatic_cast(impl::SharedMutex *, sm)->wrunlock ());
+}
+
+
+} } // namespace log4cplus { namespace thread { 
+} // end namespace dcmtk
+
+#endif // DCMTK_LOG4CPLUS_ENABLE_SYNCPRIMS_PUB_IMPL
+
+#endif // DCMTK_LOG4CPLUS_THREAD_SYNCPRIMS_PUB_IMPL_H
diff --git a/oflog/include/dcmtk/oflog/helpers/threads.h b/oflog/include/dcmtk/oflog/thread/threads.h
similarity index 56%
rename from oflog/include/dcmtk/oflog/helpers/threads.h
rename to oflog/include/dcmtk/oflog/thread/threads.h
index eecd74d..b6ec64e 100644
--- a/oflog/include/dcmtk/oflog/helpers/threads.h
+++ b/oflog/include/dcmtk/oflog/thread/threads.h
@@ -1,3 +1,4 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    threads.h
 // Created: 6/2001
@@ -20,51 +21,37 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_THREADS_HEADER_
-#define DCMTK__LOG4CPLUS_THREADS_HEADER_
+#ifndef DCMTK_LOG4CPLUS_THREADS_HEADER_
+#define DCMTK_LOG4CPLUS_THREADS_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/tstring.h"
 #include "dcmtk/oflog/helpers/pointer.h"
 
 
-namespace dcmtk { namespace log4cplus { namespace thread {
+namespace dcmtk {
+namespace log4cplus { namespace thread {
 
-/**
- * This is used to lock a mutex.  The dtor unlocks the mutex.
- */
-class Guard
-{
-public:
-    /** "locks" <code>mutex</code>. */
-    Guard(DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE mutex)
-        : _mutex (mutex)
-    {
-        DCMTK_LOG4CPLUS_MUTEX_LOCK( _mutex );
-    }
-
-    /** "unlocks" <code>mutex</code>. */
-    ~Guard()
-    {
-        DCMTK_LOG4CPLUS_MUTEX_UNLOCK( _mutex );
-    }
 
-private:
-    DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE _mutex;
-
-    // disable copy
-    Guard(const Guard&);
-    Guard& operator=(const Guard&);
-};
+DCMTK_LOG4CPLUS_EXPORT log4cplus::tstring const & getCurrentThreadName();
+DCMTK_LOG4CPLUS_EXPORT log4cplus::tstring const & getCurrentThreadName2();
+DCMTK_LOG4CPLUS_EXPORT void yield();
+DCMTK_LOG4CPLUS_EXPORT void blockAllSignals();
 
 
 #ifndef DCMTK_LOG4CPLUS_SINGLE_THREADED
 
-DCMTK_LOG4CPLUS_EXPORT void blockAllSignals();
-DCMTK_LOG4CPLUS_EXPORT tstring getCurrentThreadName();
-
-
-struct ThreadStart;
+class ThreadImplBase
+    : public virtual log4cplus::helpers::SharedObject
+{
+protected:
+    virtual ~ThreadImplBase ();
+};
 
 
 /**
@@ -74,35 +61,21 @@ struct ThreadStart;
  * class with basic functionality.
  */
 class DCMTK_LOG4CPLUS_EXPORT AbstractThread
-    : public virtual dcmtk::log4cplus::helpers::SharedObject
+    : public virtual log4cplus::helpers::SharedObject
 {
 public:
     AbstractThread();
-    bool isRunning() const { return running; }
-    DCMTK_LOG4CPLUS_THREAD_KEY_TYPE getThreadId() const;
-    DCMTK_LOG4CPLUS_THREAD_HANDLE_TYPE getThreadHandle () const;
+    bool isRunning() const;
     virtual void start();
     void join () const;
+    virtual void run() = 0;
 
 protected:
     // Force objects to be constructed on the heap
     virtual ~AbstractThread();
-    virtual void run() = 0;
 
 private:
-    bool running;
-
-    // Friends.
-    friend struct ThreadStart;
-
-#  ifdef DCMTK_LOG4CPLUS_USE_PTHREADS
-    pthread_t handle;
-
-#  elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
-    HANDLE handle;
-    unsigned thread_id;
-
-#  endif
+    helpers::SharedObjectPtr<ThreadImplBase> thread;
 
     // Disallow copying of instances of this class.
     AbstractThread(const AbstractThread&);
@@ -115,8 +88,9 @@ typedef helpers::SharedObjectPtr<AbstractThread> AbstractThreadPtr;
 #endif // DCMTK_LOG4CPLUS_SINGLE_THREADED
 
 
-} } } // namespace dcmtk { namespace log4cplus { namespace thread {
+} } // namespace log4cplus { namespace thread {
+} // end namespace dcmtk
 
 
-#endif // DCMTK__LOG4CPLUS_THREADS_HEADER_
+#endif // DCMTK_LOG4CPLUS_THREADS_HEADER_
 
diff --git a/oflog/include/dcmtk/oflog/tracelog.h b/oflog/include/dcmtk/oflog/tracelog.h
new file mode 100644
index 0000000..c517d35
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/tracelog.h
@@ -0,0 +1,82 @@
+// -*- C++ -*-
+// Module:  Log4CPLUS
+// File:    tracelog.h
+// Created: 1/2009
+// Author:  Vaclav Haisman
+//
+//
+// Copyright 2009-2010 Tad E. Smith
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS,
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+/** @file */
+
+#ifndef DCMTK_LOG4CPLUS_TRACELOGGER_H
+#define DCMTK_LOG4CPLUS_TRACELOGGER_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/oflog/logger.h"
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+
+/**
+ * This class is used to produce "Trace" logging.  When an instance of
+ * this class is created, it will log a <code>"ENTER: " + msg</code>
+ * log message if TRACE_LOG_LEVEL is enabled for <code>logger</code>.
+ * When an instance of this class is destroyed, it will log a
+ * <code>"ENTER: " + msg</code> log message if TRACE_LOG_LEVEL is enabled
+ * for <code>logger</code>.
+ * <p>
+ * @see DCMTK_LOG4CPLUS_TRACE
+ */
+class TraceLogger
+{
+public:
+    TraceLogger(const Logger& l, const log4cplus::tstring& _msg,
+                const char* _file=NULL, int _line=-1) 
+      : logger(l), msg(_msg), file(_file), line(_line)
+    { if(logger.isEnabledFor(TRACE_LOG_LEVEL))
+          logger.forcedLog(TRACE_LOG_LEVEL, DCMTK_LOG4CPLUS_TEXT("ENTER: ") + msg, file, line); 
+    }
+
+    ~TraceLogger()
+    { if(logger.isEnabledFor(TRACE_LOG_LEVEL))
+          logger.forcedLog(TRACE_LOG_LEVEL, DCMTK_LOG4CPLUS_TEXT("EXIT:  ") + msg, file, line); 
+    }
+
+private:
+    TraceLogger (TraceLogger const &);
+    TraceLogger & operator = (TraceLogger const &);
+
+    Logger logger;
+    log4cplus::tstring msg;
+    const char* file;
+    int line;
+};
+
+
+} // log4cplus
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_TRACELOGGER_H
diff --git a/oflog/include/dcmtk/oflog/tstring.h b/oflog/include/dcmtk/oflog/tstring.h
index 3b0561d..7ca173c 100644
--- a/oflog/include/dcmtk/oflog/tstring.h
+++ b/oflog/include/dcmtk/oflog/tstring.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    tstring.h
 // Created: 4/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -24,21 +25,80 @@
 #define DCMTK_LOG4CPLUS_TSTRING_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/ofstd/ofstring.h"
+#include "dcmtk/oflog/tchar.h"
+
+namespace dcmtk
+{
+namespace log4cplus
+{
 
-#define DCMTK_LOG4CPLUS_TEXT2(STRING) STRING
-#define DCMTK_LOG4CPLUS_TEXT(STRING) DCMTK_LOG4CPLUS_TEXT2(STRING)
+typedef OFString tstring;
 
 
-namespace dcmtk {
-namespace log4cplus {
-    typedef char tchar;
-    typedef OFString tstring;
+namespace helpers
+{
+
+inline
+OFString
+tostring (char const * str)
+{
+    return OFString (str);
 }
+
+
+inline
+OFString
+tostring (OFString const & str)
+{
+    return str;
 }
 
+
+
+inline
+STD_NAMESPACE wstring
+towstring (wchar_t const * str)
+{
+    return STD_NAMESPACE wstring (str);
+}
+
+inline
+STD_NAMESPACE wstring
+towstring (STD_NAMESPACE wstring const & str)
+{
+    return str;
+}
+
+DCMTK_LOG4CPLUS_EXPORT OFString tostring(const STD_NAMESPACE wstring&);
+DCMTK_LOG4CPLUS_EXPORT OFString tostring(wchar_t const *);
+
+DCMTK_LOG4CPLUS_EXPORT STD_NAMESPACE wstring towstring(const OFString&);
+DCMTK_LOG4CPLUS_EXPORT STD_NAMESPACE wstring towstring(char const *);
+
+} // namespace helpers
+
+#ifdef UNICODE
+
+#define DCMTK_LOG4CPLUS_C_STR_TO_TSTRING(STRING) log4cplus::helpers::towstring(STRING)
+#define DCMTK_LOG4CPLUS_STRING_TO_TSTRING(STRING) log4cplus::helpers::towstring(STRING)
+#define DCMTK_LOG4CPLUS_TSTRING_TO_STRING(STRING) log4cplus::helpers::tostring(STRING)
+
+#else // UNICODE
+
 #define DCMTK_LOG4CPLUS_C_STR_TO_TSTRING(STRING) OFString(STRING)
 #define DCMTK_LOG4CPLUS_STRING_TO_TSTRING(STRING) STRING
 #define DCMTK_LOG4CPLUS_TSTRING_TO_STRING(STRING) STRING
 
+#endif // UNICODE
+
+} // namespace log4cplus
+} // end namespace dcmtk
+
+
 #endif // DCMTK_LOG4CPLUS_TSTRING_HEADER_
diff --git a/oflog/include/dcmtk/oflog/version.h b/oflog/include/dcmtk/oflog/version.h
new file mode 100644
index 0000000..aa002fd
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/version.h
@@ -0,0 +1,56 @@
+// -*- C++ -*-
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+#if ! defined (DCMTK_LOG4CPLUS_VERSION_H)
+#define DCMTK_LOG4CPLUS_VERSION_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#define DCMTK_LOG4CPLUS_MAKE_VERSION(major, minor, point) \
+    (major * 1000 * 1000u + minor * 1000u + point)
+
+#define DCMTK_LOG4CPLUS_MAKE_VERSION_STR(major, minor, point) \
+    #major "." #minor "." #point
+
+#define DCMTK_LOG4CPLUS_VERSION DCMTK_LOG4CPLUS_MAKE_VERSION(1, 1, 0)
+#define DCMTK_LOG4CPLUS_VERSION_STR DCMTK_LOG4CPLUS_MAKE_VERSION_STR(1, 1, 0)
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+extern DCMTK_LOG4CPLUS_EXPORT unsigned const version;
+extern DCMTK_LOG4CPLUS_EXPORT char const versionStr[];
+
+}
+} // end namespace dcmtk
+
+#endif
diff --git a/oflog/include/dcmtk/oflog/winconap.h b/oflog/include/dcmtk/oflog/winconap.h
index 6d49e78..e5885fe 100644
--- a/oflog/include/dcmtk/oflog/winconap.h
+++ b/oflog/include/dcmtk/oflog/winconap.h
@@ -1,35 +1,39 @@
-//   Copyright (C) 2009, Vaclav Haisman. All rights reserved.
-//
-//   Redistribution and use in source and binary forms, with or without modifica-
-//   tion, are permitted provided that the following conditions are met:
-//
-//   1. Redistributions of  source code must  retain the above copyright  notice,
-//      this list of conditions and the following disclaimer.
-//
-//   2. Redistributions in binary form must reproduce the above copyright notice,
-//      this list of conditions and the following disclaimer in the documentation
-//      and/or other materials provided with the distribution.
-//
-//   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
-//   INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
-//   FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
-//   APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
-//   INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
-//   DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
-//   OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
-//   ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
-//   (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
-//   THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+// -*- C++ -*-
+//  Copyright (C) 2009-2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 #ifndef DCMTK_LOG4CPLUS_WIN32CONSOLEAPPENDER_H
 #define DCMTK_LOG4CPLUS_WIN32CONSOLEAPPENDER_H
 
-
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #if defined(_WIN32) && defined (DCMTK_LOG4CPLUS_HAVE_WIN32_CONSOLE)
 
 #include "dcmtk/oflog/appender.h"
-#include "dcmtk/oflog/helpers/property.h"
 
 
 namespace dcmtk
@@ -54,7 +58,7 @@ namespace log4cplus
     {
     public:
         explicit Win32ConsoleAppender (bool allocConsole = true);
-        Win32ConsoleAppender (helpers::Properties const & properties, tstring& error);
+        Win32ConsoleAppender (helpers::Properties const & properties);
         virtual ~Win32ConsoleAppender ();
 
         virtual void close ();
@@ -62,8 +66,8 @@ namespace log4cplus
     protected:
         virtual void append (spi::InternalLoggingEvent const &);
 
-        void write_handle (HANDLE, tchar const *, size_t);
-        void write_console (HANDLE, tchar const *, size_t);
+        void write_handle (void *, tchar const *, size_t);
+        void write_console (void *, tchar const *, size_t);
 
         bool alloc_console;
 
@@ -73,7 +77,7 @@ namespace log4cplus
     };
 
 } // namespace log4cplus
-} // namespace dcmtk
+} // end namespace dcmtk
 
 #endif
 
